org.apache.commons.io.input

## Class BrokenReader

- java.lang.Object
- - java.io.Reader
  - - org.apache.commons.io.input.BrokenReader

- All Implemented Interfaces:
    Closeable, AutoCloseable, Readable

      public class BrokenReader
      extends Reader

  Always throws an `IOException` from all the `Reader` methods where the exception is declared.

  This class is mostly useful for testing error handling.

  Since:
    2.7

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static BrokenReader` | `INSTANCE` A singleton instance using a default IOException.

    - ### Fields inherited from class java.io.Reader

      `lock`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BrokenReader()` Creates a new reader that always throws an `IOException`.
    `BrokenReader(IOException exception)` Creates a new reader that always throws the given exception.
    `BrokenReader(Supplier<IOException> exceptionSupplier)` Creates a new reader that always throws an `IOException`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Throws the configured exception.
    `void` | `mark(int readAheadLimit)` Throws the configured exception.
    `int` | `read(char[] cbuf, int off, int len)` Throws the configured exception.
    `boolean` | `ready()` Throws the configured exception.
    `void` | `reset()` Throws the configured exception.
    `long` | `skip(long n)` Throws the configured exception.

    - ### Methods inherited from class java.io.Reader

      `markSupported, read, read, read`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### INSTANCE

          public static final BrokenReader INSTANCE

      A singleton instance using a default IOException.
      Since:
        2.12.0

  - ### Constructor Detail

    - #### BrokenReader

          public BrokenReader()

      Creates a new reader that always throws an `IOException`.

    - #### BrokenReader

          public BrokenReader(IOException exception)

      Creates a new reader that always throws the given exception.
      Parameters:
        `exception` - the exception to be thrown.

    - #### BrokenReader

          public BrokenReader(Supplier<IOException> exceptionSupplier)

      Creates a new reader that always throws an `IOException`
      Parameters:
        `exceptionSupplier` - a supplier for the exception to be thrown.
      Since:
        2.12.0

  - ### Method Detail

    - #### close

          public void close()
                     throws IOException

      Throws the configured exception.
      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Specified by:
        `close` in class `Reader`
      Throws:
        `IOException` - always thrown

    - #### mark

          public void mark(int readAheadLimit)
                    throws IOException

      Throws the configured exception.
      Overrides:
        `mark` in class `Reader`
      Parameters:
        `readAheadLimit` - ignored
      Throws:
        `IOException` - always thrown

    - #### read

          public int read(char[] cbuf,
                          int off,
                          int len)
                   throws IOException

      Throws the configured exception.
      Specified by:
        `read` in class `Reader`
      Parameters:
        `cbuf` - ignored
        `off` - ignored
        `len` - ignored
      Returns:
        nothing
      Throws:
        `IOException` - always thrown

    - #### ready

          public boolean ready()
                        throws IOException

      Throws the configured exception.
      Overrides:
        `ready` in class `Reader`
      Returns:
        nothing
      Throws:
        `IOException` - always thrown

    - #### reset

          public void reset()
                     throws IOException

      Throws the configured exception.
      Overrides:
        `reset` in class `Reader`
      Throws:
        `IOException` - always thrown

    - #### skip

          public long skip(long n)
                    throws IOException

      Throws the configured exception.
      Overrides:
        `skip` in class `Reader`
      Parameters:
        `n` - ignored
      Returns:
        nothing
      Throws:
        `IOException` - always thrown

Copyright © 2002–2023 The Apache Software Foundation. All rights reserved.